<?php
/**
 * @category   DeliveryPerson
 * @package    DeliveryPerson_DeliveryModule
 * @author     prashant.bluethink@gmail.com
 * @copyright  This file was generated by using Module Creator(http://code.vky.co.in/magento-2-module-creator/) provided by VKY <viky.031290@gmail.com>
 * @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 */

namespace DeliveryPerson\DeliveryModule\Block;

use Magento\Framework\View\Element\Template\Context;
use DeliveryPerson\DeliveryModule\Model\DeliveryModuleFactory;
/**
 * DeliveryModule List block
 */
class DeliveryModuleListData extends \Magento\Framework\View\Element\Template
{
    /**
     * @var DeliveryModule
     */
    protected $_deliverymodule;
    public function __construct(
        Context $context,
        DeliveryModuleFactory $deliverymodule
    ) {
        $this->_deliverymodule = $deliverymodule;
        parent::__construct($context);
    }

    public function _prepareLayout()
    {
        $this->pageConfig->getTitle()->set(__('DeliveryPerson DeliveryModule Module List Page'));
        
        if ($this->getDeliveryModuleCollection()) {
            $pager = $this->getLayout()->createBlock(
                'Magento\Theme\Block\Html\Pager',
                'deliveryperson.deliverymodule.pager'
            )->setAvailableLimit(array(5=>5,10=>10,15=>15))->setShowPerPage(true)->setCollection(
                $this->getDeliveryModuleCollection()
            );
            $this->setChild('pager', $pager);
            $this->getDeliveryModuleCollection()->load();
        }
        return parent::_prepareLayout();
    }

    public function getDeliveryModuleCollection()
    {
        $page = ($this->getRequest()->getParam('p'))? $this->getRequest()->getParam('p') : 1;
        $pageSize = ($this->getRequest()->getParam('limit'))? $this->getRequest()->getParam('limit') : 5;

        $deliverymodule = $this->_deliverymodule->create();
        $collection = $deliverymodule->getCollection();
        $collection->addFieldToFilter('status','1');
        //$deliverymodule->setOrder('deliverymodule_id','ASC');
        $collection->setPageSize($pageSize);
        $collection->setCurPage($page);

        return $collection;
    }

    public function getPagerHtml()
    {
        return $this->getChildHtml('pager');
    }
}